/*
================================================================================
 File: converter.h
--------------------------------------------------------------------------------
 Author:        Piotr Wojtowicz
 Purpose:       USBD RS232C converter
 Compiler:      ANSI C
 Hardware:
 Doc:
--------------------------------------------------------------------------------
 Includes:
--------------------------------------------------------------------------------
 Comments:                      UWAGA!!!
                Oprogramowanie to udostpnione jest do celw pogldowych,
                nie jest przetestowane pod ktem bezpieczestwa ani spenienia
                jakichkolwiek norm wymaganych aby urzdzenie uywajce go
                mogo by dopuszczone do uytku, dlatego uywasz go
                na wasn odpowiedzialno a jego autor nie ponosi adnego
                typu odpowiedzialnoci za jakiekolwiek skutki jego uycia.
                Jeeli nie zgadzasz si z powyszym warunkiem prosz
                o nieuywanie tego oprogramowania.
================================================================================
*/

#ifndef CONVERTER_H_
#define CONVERTER_H_

#include <stdint.h>
#include <stdlib.h>
#include <string.h>
#include "stm32f10x_conf.h"
#include "cdc_vcom.h"
#include "buffers.h"
#include "config.h"



#define USE_VCOM1					1
#define USE_VCOM2					1

#if(USE_VCOM1)
#define VCOM1_USART_NUM				1
#endif

#if(USE_VCOM2)
#define VCOM2_USART_NUM				3
#endif






#define LED1_PORT						GPIOC
#define LED1_PIN						GPIO_Pin_12
#define LED1_PIN_MODE					GPIO_Mode_Out_PP








#define TO_VCOM_BUF_SIZE			1000
#define TO_USART_BUF_SIZE			1000


typedef struct {
	USART_TypeDef* USARTx;
	uint8_t usart_num;
	uint8_t usart_activity;
	volatile uint8_t irq_wfr_state;
	uint8_t tx_data;
	uint8_t tx_state;
	uint8_t ring_state;
	uint8_t dcd_state;
	uint8_t dsr_state;
	CDC_VCOM_params vcom;
	struct {
		TBuffer to_vcom;
		TBuffer to_usart;
	}buf;
	struct {
		uint8_t rx[USBDEP_FS_BULK_MAX_POSSIBLE_PACKET_SIZE];
		uint8_t tx[USBDEP_FS_BULK_MAX_POSSIBLE_PACKET_SIZE];
	}cache;
	struct {
		uint8_t to_vcom[TO_VCOM_BUF_SIZE];
		uint8_t to_usart[TO_USART_BUF_SIZE];
	}space;
}converter_params;


void converter_init(void);

void converter_usarts_signals_scan(void);

#endif /*CONVERTER_H_*/
