/*
================================================================================
 File: oprint.h
--------------------------------------------------------------------------------
 Author:        Piotr Wojtowicz
 Purpose:       simple object print library
 Compiler:      ANSI C
 Hardware:      
 Doc:
--------------------------------------------------------------------------------
 Includes:      
--------------------------------------------------------------------------------
 Comments:                      UWAGA!!!
                Oprogramowanie to udostpnione jest do celw pogldowych,
                nie jest przetestowane pod ktem bezpieczestwa ani spenienia
                jakichkolwiek norm wymaganych aby urzdzenie uywajce go
                mogo by dopuszczone do uytku, dlatego uywasz go
                na wasn odpowiedzialno a jego autor nie ponosi adnego
                typu odpowiedzialnoci za jakiekolwiek skutki jego uycia.
                Jeeli nie zgadzasz si z powyszym warunkiem prosz
                o nieuywanie tego oprogramowania.
================================================================================
*/

#ifndef OPRINT_H_
#define OPRINT_H_
#include <stdint.h>


/********************************************************************************/
/*                              Public types                                    */
/********************************************************************************/

typedef struct {
	void (*print_text)(void *dev, const char *string);
	void (*set_pos)(void *dev, uint32_t x, uint32_t y);
	void (*clear_display)(void *dev);
}oprint_exe_params;


/********************************************************************************/
/*                              Public data                                     */
/********************************************************************************/

extern const char endl[2];


/********************************************************************************/
/*                              Public functions                                */
/********************************************************************************/

void oprint_set_dev(void *dev);
void oprint_set_default_dev(void *dev);

void oprint_set_exe(oprint_exe_params *exe);
void oprint_set_default_exe(oprint_exe_params *exe);


uint8_t oprint_uint4_to_ascii(uint8_t lower_half_data);


void oprint_string(oprint_exe_params *exe, void *dev, const char *string);
void oprint_data (oprint_exe_params *exe, void *dev, uint32_t data, uint8_t length, uint16_t params);
void oprint_pos(oprint_exe_params *exe, void *dev, uint32_t x, uint32_t y);
void oprint_clear(oprint_exe_params *exe, void *dev);

void print_string(const char *string);
void print_data (uint32_t data, uint8_t length, uint16_t params);
void print_pos(uint32_t x, uint32_t y);
void print_clear(void);

#endif /*OPRINT_H_*/
