/*
================================================================================
 File: stm32_usart_init.h
--------------------------------------------------------------------------------
 Author:        Piotr Wojtowicz
 Purpose:       usart initialization procedure for stm32
 Compiler:      ANSI C
 Hardware:
 Doc:
--------------------------------------------------------------------------------
 Includes:
--------------------------------------------------------------------------------
 Comments:                      UWAGA!!!
                Oprogramowanie to udostpnione jest do celw pogldowych,
                nie jest przetestowane pod ktem bezpieczestwa ani spenienia
                jakichkolwiek norm wymaganych aby urzdzenie uywajce go
                mogo by dopuszczone do uytku, dlatego uywasz go
                na wasn odpowiedzialno a jego autor nie ponosi adnego
                typu odpowiedzialnoci za jakiekolwiek skutki jego uycia.
                Jeeli nie zgadzasz si z powyszym warunkiem prosz
                o nieuywanie tego oprogramowania.
================================================================================
*/

#ifndef STM32_USART_INIT_H_
#define STM32_USART_INIT_H_

#include <stdint.h>

#include <string.h>
#include "oprint.h"


#define USART1_TX_PORT				GPIOA
#define USART1_TX_PIN				GPIO_Pin_9

#define USART1_RX_PORT				GPIOA
#define USART1_RX_PIN				GPIO_Pin_10



#define USART2_TX_PORT				GPIOA
#define USART2_TX_PIN				GPIO_Pin_2

#define USART2_RX_PORT				GPIOA
#define USART2_RX_PIN				GPIO_Pin_3



#define USART3_TX_PORT				GPIOB
#define USART3_TX_PIN				GPIO_Pin_10

#define USART3_RX_PORT				GPIOB
#define USART3_RX_PIN				GPIO_Pin_11



void configure_usart(uint8_t usart_num, uint32_t baudrate, uint16_t stop_bits, uint16_t patity, uint8_t enable_irq);
void deconfigure_usart(uint8_t usart_num);
void init_oprint(uint8_t usart_num);


#endif /* STM32_USART_INIT_H_ */
