/*
================================================================================
 File: usbd_port_trash.h
--------------------------------------------------------------------------------
 Author:        Piotr Wojtowicz
 Purpose:       USBD trash
 Compiler:      ANSI C
 Hardware:      
 Doc:
--------------------------------------------------------------------------------
 Includes:      
--------------------------------------------------------------------------------
 Comments:                      UWAGA!!!
                Oprogramowanie to udostępnione jest do celów poglądowych,
                nie jest przetestowane pod kątem bezpieczeństwa ani spełnienia
                jakichkolwiek norm wymaganych aby urządzenie używające go
                mogło być dopuszczone do użytku, dlatego używasz go
                na własną odpowiedzialność a jego autor nie ponosi żadnego
                typu odpowiedzialności za jakiekolwiek skutki jego użycia.
                Jeżeli nie zgadzasz się z powyższym warunkiem proszę
                o nieużywanie tego oprogramowania.
================================================================================
*/

#ifndef USBD_PORT_TRASH_H_
#define USBD_PORT_TRASH_H_

#ifndef USBD_H_
#include "usbd.h"
#endif


/****************************************************************************/
/*               USBD_DP_PULL_UP                                            */
/****************************************************************************/

#if(USBD_DP_PULL_UP_SUPPORT == USBD_FEATURE_ON)
// funkcja sluzaca do wlaczenia rezystora Pull-Up na linii USBDP
void USBD_DP_PULL_UP_enable(void);

// funkcja sluzaca do wylaczenia rezystora Pull-Up na linii USBDP
void USBD_DP_PULL_UP_disable(void);
#endif


/****************************************************************************/
/*               USBD_VBUS_DETECT                                           */
/****************************************************************************/

#if (USBD_VBUS_DETECT_SUPPORT == USBD_FEATURE_ON)
// zwraca 1 jezeli na lini VBUS jest napiecie zasilania od Hosta
// w przeciwnym wypadku zwraca 0
uint8_t USBD_device_is_powered(void);

// przekonfigurowuje przerwanie od wykrycia polaczenia z Hostem
void USBD_VBUS_DETECT_reconfigure_irq(uint8_t state);

// funkcja wywolywana jako przerwanie od zmiany stanu na linii VBUS_DETECT
void USBD_Attach_irq_handler(void);
#endif


/****************************************************************************/
/*               USBD peripheral manage                                     */
/****************************************************************************/

void USBD_low_level_init(void);

#if (((USBDE_WAKEUP_SUPPORT == USBD_FEATURE_ON) || (USBDE_SUSPENDED_SUPPORT == USBD_FEATURE_ON)) &&  (USBD_MAX_NUM_EVENTS > 0))
void USBD_clear_wakeup_exti_status(void);
#endif

void USBD_power_up(void);

void USBD_power_down(void);


#endif /*USBD_PORT_TRASH_H_*/
